Index: branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh	(revision 571)
@@ -800,310 +854,323 @@
 function IGCM_comp_Finalize
 {
-    IGCM_debug_PushStack "IGCM_comp_Finalize"
-
-    # Debug Print :
+  IGCM_debug_PushStack "IGCM_comp_Finalize"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_Finalize"
+  echo
+
+  typeset ListTextName TextName0
+  typeset comp compname comptagname card ListFilesName FileName0 NbFiles SaveOnArchive
+  typeset i i_ file_in file_in_ file_out file_out_ file_outin file_outin_ generic_file_name nb_rebuild_file
+  typeset -Z4 j4
+  typeset list_file nlist_file
+  typeset compactoutputs
+
+  compactoutputs=false
+  if [ X${JobType} != XRUN ] ; then
+    compactoutputs=true
+  elif [ X${config_UserChoices_CompactText} != Xn ] ; then
+    compactoutputs=true
+  fi
+
+  for comp in ${config_ListOfComponents[*]} ; do
+    # Define component 
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
+
+    # Debug Print
+    IGCM_debug_Print 1 "Finalize ${comp} : ${compname} component."
+    # FINALIZE component
+    ${comp}_Finalize
+
+    card=${SUBMIT_DIR}/COMP/${compname}.card	
+
+    # Save Restarts files
+    #--------------------
+    IGCM_debug_Print 2 "Save Restart files for ${comp} : ${compname} component."
+    IGCM_card_DefineArrayFromOption ${card} RestartFiles List
+    ListFilesName=${compname}_RestartFiles_List
+    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
+    
+    if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
+      eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+      
+      (( i=0 ))
+      until [ $i -ge $NbFiles ]; do
+	eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	eval file_in=${file_in_}
+
+	(( i_ = i+1 ))
+	eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	eval file_out=${file_out_}
+
+	(( i_ = i+2 ))
+	eval file_outin_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	eval file_outin=${file_outin_}
+
+	generic_restart_file_name_in=$(    basename ${file_in} .nc )
+	generic_restart_file_name_out=$(   basename ${config_UserChoices_JobName}_${PeriodDateEnd}_${file_out} .nc )
+	generic_restart_file_name_outin=$( basename ${file_outin} .nc )
+	
+	nb_restart_file=$( ls ${generic_restart_file_name_in}_????.nc 2>/dev/null | wc -l ) 
+	if [ ${nb_restart_file} -gt 1 ] ; then
+	  j=0
+	  until [ $j -ge $nb_restart_file ]; do
+	    j4=${j}
+            if [ X${Pack} = Xtrue ] ; then
+	      eval IGCM_sys_PutBuffer_Rest ${generic_restart_file_name_in}_${j4}.nc \${R_BUF_${comp}_R}/${generic_restart_file_name_out}_${j4}.nc
+            else
+	      eval IGCM_sys_Put_Rest       ${generic_restart_file_name_in}_${j4}.nc \${R_OUT_${comp}_R}/${generic_restart_file_name_out}_${j4}.nc
+            fi
+	    if [ ! ${file_in} = ${file_outin} ] ; then
+	      if ( ${ExitFlag} ) ; then
+		echo "IGCM_sys_Mv ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_outin}_${j4}.nc not executed."
+	      else
+		IGCM_sys_Mv ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_outin}_${j4}.nc
+	      fi
+	    fi
+	    (( j=j+1 ))
+	  done
+	else
+          if [ X${Pack} = Xtrue ] ; then
+	    eval IGCM_sys_PutBuffer_Rest ${file_in} \${R_BUF_${comp}_R}/${config_UserChoices_JobName}_${PeriodDateEnd}_${file_out}
+          else
+  	    eval IGCM_sys_Put_Rest       ${file_in} \${R_OUT_${comp}_R}/${config_UserChoices_JobName}_${PeriodDateEnd}_${file_out}
+          fi
+	  if [ ! ${file_in} = ${file_outin} ] ; then
+	    if ( ${ExitFlag} ) ; then
+	      echo "IGCM_sys_Mv ${file_in} ${file_outin} not executed."
+	    else
+	      IGCM_sys_Mv ${file_in} ${file_outin}
+	    fi
+	  fi
+	fi
+
+	(( i=i+3 ))
+      done
+    else
+      if [ X${FileName0} != XNONE ] ; then
+	IGCM_debug_Exit "IGCM_comp_Finalize : No file in restart list for ${compname}."
+      else
+	IGCM_debug_Print 1 "IGCM_comp_Finalize : NONE specified in Restart List ${compname}."
+      fi
+    fi
+
+    # Save Output files
+    #------------------
+    IGCM_debug_Print 2 "Save Output files for ${comp} : ${compname} component."
+    IGCM_card_DefineArrayFromOption ${card} OutputFiles List
+    ListFilesName=${compname}_OutputFiles_List
+    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
+
+    if [ X${FileName0} != X${NULL_STR} ] ; then
+      eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+
+      (( i=0 ))
+      until [ $i -ge $NbFiles ]; do
+	SaveOnArchive=true
+	eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	eval file_in=${file_in_}
+	(( i_ = i+1 ))
+	eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	eval file_out=${file_out_}
+	(( i_ = i+2 ))
+	eval flag_post=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	#
+	generic_file_name=$( basename ${file_in} .nc )
+	nb_rebuild_file=$( ls | grep "^${generic_file_name}_[0-9]*.nc" | wc -l )
+	#
+	if ( [ ${nb_rebuild_file} -eq 1 ] && [ -f ${generic_file_name}_0000.nc ] ) ; then
+	  IGCM_debug_Print 2 "Parallelism with 1 process. Rebuilding ${file_in} not needed"
+	  IGCM_sys_Mv ${generic_file_name}_0000.nc ${file_in}
+	elif [ ${nb_rebuild_file} -gt 1 ] ; then
+	  IGCM_debug_Print 2 "Parallelism detected rebuilding ${file_in} is needed"
+	  if [ X${AsynchronousRebuild} = Xfalse ] ; then
+	    IGCM_debug_Print 2 "Rebuilding ${file_in} online"
+	    IGCM_sys_rebuild ${file_in} ${generic_file_name}_*.nc
+	  else
+	    IGCM_debug_Print 2 "Preparing offline rebuild for ${file_in}"
+	    [ ! -d ${RUN_DIR}/REBUILD_${PeriodDateBegin} ] && IGCM_sys_Mkdir ${RUN_DIR}/REBUILD_${PeriodDateBegin}
+	    IGCM_sys_Mv ${generic_file_name}_????.nc ${RUN_DIR}/REBUILD_${PeriodDateBegin}
+
+	    # Prepare headers for the shell dedicated to offline rebuild
+	    if [ ! -f ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh ] ; then
+	      if [ $DRYRUN -le 1 ]; then
+		echo "#!/bin/ksh                                        " >  ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "function IGCM_FlushRebuild                        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "{                                                 " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_debug_PushStack \"IGCM_FlushRebuild\"        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "echo                                              " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_debug_Print 1 \"IGCM_FlushRebuild\"          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "echo                                              " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "export R_SAVE=${R_SAVE}                           " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "export config_UserChoices_JobName=${config_UserChoices_JobName} " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      fi
+	    fi
+	    # Prepare the shell dedicated to offline rebuild
+	    if [ $DRYRUN -le 1 ]; then
+	      echo "IGCM_sys_rebuild ${file_in} ${generic_file_name}_*.nc" >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      echo "IGCM_debug_Verif_Exit_Post                           " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	    fi
+	    #
+	    # Load Patch we need to apply and apply
+	    if [ $DRYRUN -le 1 ]; then
+	      if [ X$( eval echo \${${compname}_${flag_post}_Patches[0]} ) !=  X${NULL_STR} ]; then
+		for Patch in $( eval echo \${${compname}_${flag_post}_Patches[*]} ); do
+		  echo ". ${libIGCM_POST}/libIGCM_post/IGCM_${Patch}.ksh" >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		  echo "IGCM_${Patch} ${file_in}                        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		  echo "IGCM_debug_Verif_Exit_Post                      " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		done
+	      fi
+	    fi
+	    #
+	    if [ $DRYRUN -le 1 ]; then
+	      echo "IGCM_sys_Put_Out ${file_in} ${file_out}             " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      echo "IGCM_debug_Verif_Exit_Post                          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      echo "IGCM_sys_Rm ${generic_file_name}_*.nc               " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	    fi
+	    SaveOnArchive=false
+	  fi
+	fi
+	#
+	if [ ${SaveOnArchive} = true ] ; then
+	  #
+	  # Rebuild has been done online or it was not needed
+	  #
+	  # If we need to apply a patch we use TMP DIRECTORY before ARCHIVING if asynchronous rebuild is on
+	  #
+	  thereisapatch=$( eval echo \${${compname}_${flag_post}_Patches[0]} )
+	  if ( [ ! X${thereisapatch} = X${NULL_STR} ] && [ X${AsynchronousRebuild} = Xtrue ] && [ -f ${file_in} ] ) ; then
+	    [ ! -d ${RUN_DIR}/REBUILD_${PeriodDateBegin} ] && IGCM_sys_Mkdir ${RUN_DIR}/REBUILD_${PeriodDateBegin}
+	    IGCM_sys_Mv ${file_in} ${RUN_DIR}/REBUILD_${PeriodDateBegin}
+	    eval FileToBeDeleted[${#FileToBeDeleted[@]}]=REBUILD_${PeriodDateBegin}/${file_in} > /dev/null 2>&1
+	    #
+	    if [ $DRYRUN -le 1 ]; then
+	      if [ ! -f ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh ] ; then
+		echo "#!/bin/ksh                                      " >  ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "function IGCM_FlushRebuild                      " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "{                                               " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_debug_PushStack \"IGCM_FlushRebuild\"      " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "echo                                            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_debug_Print 1 \"IGCM_FlushRebuild\"        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "echo                                            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "export R_SAVE=${R_SAVE}                         " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "export config_UserChoices_JobName=${config_UserChoices_JobName} " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      fi
+              #
+	      for Patch in $( eval echo \${${compname}_${flag_post}_Patches[*]} ); do
+		echo ". ${libIGCM_POST}/libIGCM_post/IGCM_${Patch}.ksh" >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_${Patch} ${file_in}                        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+		echo "IGCM_debug_Verif_Exit_Post                      " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      done
+	      #
+	      echo "IGCM_sys_Put_Out ${file_in} ${file_out}           " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      echo "IGCM_debug_Verif_Exit_Post                        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
+	      #
+	    fi
+	  else
+	    #
+	    # No Patch, No Asynchronous rebuild, online rebuild has been done or was not needed
+	    #
+	    IGCM_sys_Put_Out ${file_in} ${file_out}
+	    eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_in}" > /dev/null 2>&1
+	    if [ ${nb_rebuild_file} -gt 1 ] ; then
+	      for DelFile in $( ls | grep "${generic_file_name}[_0-9]*.nc" ) ; do
+		eval FileToBeDeleted[${#FileToBeDeleted[@]}]=${DelFile} > /dev/null 2>&1
+	      done
+	    fi
+	  fi
+	fi
+	(( i=i+3 ))
+      done
+    fi
+
+    # Save Output Text files of models
+    #---------------------------------
+    IGCM_debug_Print 2 "Save Output Text files for ${comp} : ${compname} component."
+    IGCM_card_DefineArrayFromOption ${card} OutputText List
+    ListTextName=${compname}_OutputText_List
+    
+    eval TextName0=\${${ListTextName}[0]} > /dev/null 2>&1
+    if [ X${TextName0} != X${NULL_STR} ] ; then
+      eval NbFiles=\${#${ListTextName}[@]} > /dev/null 2>&1
+
+      (( i=0 ))
+      until [ $i -eq $NbFiles ]; do
+	eval file_in=\${${ListTextName}[$i]} > /dev/null 2>&1
+	eval file_out=${PREFIX}_${file_in}
+
+	(( i=i+1 ))
+
+	unset list_file
+	#set +A list_file -- $( ls ${file_in}* | sort 2>/dev/null )
+        # result for a a1 a10 a2 with file_in=a a a1 a2 a10
+	set +A list_file -- $( [ -f ${file_in} ] && ls ${file_in} ; for i in $(ls ${file_in}* 2>/dev/null | sed "s/${file_in}//" | sort -n) ; do ls ${file_in}$i ; done )
+	nlist_file=${#list_file[@]}
+	  if [ ${nlist_file} -gt 1 ] ; then
+	    if ( ${compactoutputs} ) ; then
+	      IGCM_debug_Print 2 "Parallelism of Text Output with ${nlist_file} files."
+	      IGCM_debug_Print 2 "Compact files in ${file_out} : " ${list_file[*]}
+	      echo ${list_file[*]} > ${file_out}
+	      echo "
+" >> ${file_out}
+	      
+	      (( i_ = 0 ))
+	      for file in ${list_file[@]}
+	      do
+		echo "_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ " >> ${file_out}
+		echo "| " ${i_} " " ${file} >> ${file_out}
+		echo "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - " >> ${file_out}
+		cat ${file} | sed "s/\(.*\)/${i_}\1/" ${file} >> ${file_out}
+		echo "
+" >> ${file_out}
+		eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file}" > /dev/null 2>&1
+		    (( i_ = i_ + 1 ))
+	      done
+	      if [ X${Pack} = Xtrue ] ; then
+	        eval IGCM_sys_PutBuffer_Out ${file_out} \${R_BUF_${comp}_D}/${file_out}
+              else
+	        eval IGCM_sys_Put_Out       ${file_out} \${R_OUT_${comp}_D}/${file_out}
+              fi
+	      eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_out}" > /dev/null 2>&1
+
+	      if ( ${ExecutionFail} ) ; then
+		IGCM_sys_Cp ${file_out} ${SUBMIT_DIR}/Debug
+	      fi
+	    else
+	      for file in ${list_file[@]}
+	      do
+		if [ X${Pack} = Xtrue ] ; then
+		  eval IGCM_sys_PutBuffer_Out ${file} \${R_BUF_${comp}_D}/${PREFIX}_${file}
+                else
+		  eval IGCM_sys_Put_Out       ${file} \${R_OUT_${comp}_D}/${PREFIX}_${file}
+                fi
+		eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file}" > /dev/null 2>&1
+
+		if ( ${ExecutionFail} ) ; then
+		  IGCM_sys_Cp ${file} ${SUBMIT_DIR}/Debug/${PREFIX}_${file}
+		fi
+	      done
+	    fi
+	  else
+	    if ( [ -f ${file_in}_0000 ] || [ -f ${file_in}0 ] ) ; then
+	      eval IGCM_sys_Mv ${file_in}* ${file_in}
+	    fi
+	    if [ X${Pack} = Xtrue ] ; then
+	      eval IGCM_sys_PutBuffer_Out ${file_in} \${R_BUF_${comp}_D}/${file_out}
+            else
+	      eval IGCM_sys_Put_Out       ${file_in} \${R_OUT_${comp}_D}/${file_out}
+            fi
+	    eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_in}" > /dev/null 2>&1
+
+	    if ( ${ExecutionFail} ) ; then
+	      IGCM_sys_Cp ${file_in} ${SUBMIT_DIR}/Debug/${file_out}
+	    fi
+	  fi
+      done
+    fi
     echo
-    IGCM_debug_Print 1 "IGCM_comp_Finalize"
-    echo
-
-    typeset ListTextName TextName0
-    typeset comp compname comptagname card ListFilesName FileName0 NbFiles SaveOnArchive
-    typeset i i_ file_in file_in_ file_out file_out_ file_outin file_outin_ generic_file_name nb_rebuild_file
-    typeset -Z4 j4
-    typeset list_file nlist_file
-    typeset compactoutputs
-
-    compactoutputs=false
-    if [ X${JobType} != XRUN ] ; then
-	compactoutputs=true
-    elif [ X${config_UserChoices_CompactText} != Xn ] ; then
-	compactoutputs=true
-    fi
-
-    for comp in ${config_ListOfComponents[*]} ; do
-	# Define component 
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-
-	# Debug Print
-	IGCM_debug_Print 1 "Finalize ${compname} component."
-	# FINALIZE component
-        ${comp}_Finalize
-
-	card=${SUBMIT_DIR}/COMP/${compname}.card	
-
-	# Save Restarts files
-	#--------------------
-	IGCM_card_DefineArrayFromOption ${card} RestartFiles List
-	ListFilesName=${compname}_RestartFiles_List
-	eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-	
-	if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
-	    eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-	    
-	    (( i=0 ))
-	    until [ $i -ge $NbFiles ]; do
-		eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		eval file_in=${file_in_}
-
-		(( i_ = i+1 ))
-		eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		eval file_out=${file_out_}
-
-		(( i_ = i+2 ))
-		eval file_outin_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		eval file_outin=${file_outin_}
-
-		generic_restart_file_name_in=$(    basename ${file_in} .nc )
-		generic_restart_file_name_out=$(   basename ${config_UserChoices_JobName}_${PeriodDateEnd}_${file_out} .nc )
-		generic_restart_file_name_outin=$( basename ${file_outin} .nc )
-			
-		nb_restart_file=$( ls ${generic_restart_file_name_in}_????.nc 2>/dev/null | wc -l ) 
-		if [ ${nb_restart_file} -gt 1 ] ; then
-		    j=0
-		    until [ $j -ge $nb_restart_file ]; do
-			j4=${j}
-			eval IGCM_sys_Put_Rest ${generic_restart_file_name_in}_${j4}.nc \${R_OUT_${comp}_R}/${generic_restart_file_name_out}_${j4}.nc
-			if [ ! ${file_in} = ${file_outin} ] ; then
-			    if ( ${ExitFlag} ) ; then
-				echo "IGCM_sys_Mv ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_outin}_${j4}.nc not executed."
-			    else
-				IGCM_sys_Mv ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_outin}_${j4}.nc
-			    fi
-			fi
-			#eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${generic_restart_file_name_in}_${j4}.nc" > /dev/null 2>&1
-			(( j=j+1 ))
-		    done
-		else
-		    eval IGCM_sys_Put_Rest ${file_in} \${R_OUT_${comp}_R}/${config_UserChoices_JobName}_${PeriodDateEnd}_${file_out}
-		    if [ ! ${file_in} = ${file_outin} ] ; then
-			if ( ${ExitFlag} ) ; then
-			    echo "IGCM_sys_Mv ${file_in} ${file_outin} not executed."
-			else
-			    IGCM_sys_Mv ${file_in} ${file_outin}
-			fi
-		    fi
-		    #eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_in}" > /dev/null 2>&1
-		fi
-
-		(( i=i+3 ))
-	    done
-	else
-	    if [ X${FileName0} != XNONE ] ; then
-		IGCM_debug_Exit "IGCM_comp_Finalize : No file in restart list for ${compname}."
-	    else
-		IGCM_debug_Print 1 "IGCM_comp_Finalize : NONE specified in Restart List ${compname}."
-	    fi
-	fi
-
-	# Save Output files
-	#------------------
-	IGCM_card_DefineArrayFromOption ${card} OutputFiles List
-	ListFilesName=${compname}_OutputFiles_List
- 	eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-
-	if [ X${FileName0} != X${NULL_STR} ] ; then
-	    eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-
-	    (( i=0 ))
-	    until [ $i -ge $NbFiles ]; do
-		SaveOnArchive=true
-		eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		eval file_in=${file_in_}
-		(( i_ = i+1 ))
-		eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		eval file_out=${file_out_}
-		(( i_ = i+2 ))
-		eval flag_post=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		#
-		generic_file_name=$( basename ${file_in} .nc )
-		nb_rebuild_file=$( ls | grep "^${generic_file_name}_[0-9]*.nc" | wc -l )
-		#
-		if ( [ ${nb_rebuild_file} -eq 1 ] && [ -f ${generic_file_name}_0000.nc ] ) ; then
-		    IGCM_debug_Print 2 "Parallelism with 1 process. Rebuilding ${file_in} not needed"
-		    IGCM_sys_Mv ${generic_file_name}_0000.nc ${file_in}
-		elif [ ${nb_rebuild_file} -gt 1 ] ; then
-		    IGCM_debug_Print 2 "Parallelism detected rebuilding ${file_in} is needed"
-		    if ( [ X${config_Post_RebuildFrequency} = X${NULL_STR} ] || [ X${config_Post_RebuildFrequency} = XNONE ] ) ; then
-			IGCM_debug_Print 2 "Rebuilding ${file_in} online"
-			IGCM_sys_rebuild ${file_in} ${generic_file_name}_*.nc
-		    else
-			IGCM_debug_Print 2 "Preparing offline rebuild for ${file_in}"
-			[ ! -d ${RUN_DIR}/REBUILD_${PeriodDateBegin} ] && IGCM_sys_Mkdir ${RUN_DIR}/REBUILD_${PeriodDateBegin}
-			IGCM_sys_Mv ${generic_file_name}_????.nc ${RUN_DIR}/REBUILD_${PeriodDateBegin}
-
-		        # Prepare headers for the shell dedicated to offline rebuild
-			if [ ! -f ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh ] ; then
-			    if [ $DRYRUN -le 1 ]; then
-			    echo "#!/bin/ksh                                          " > ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "function IGCM_FlushRebuild                          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "{                                                   " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_PushStack \"IGCM_FlushRebuild\"          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_Print 1 \"IGCM_FlushRebuild\"            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "export R_SAVE=${R_SAVE}                             " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "export config_UserChoices_JobName=${config_UserChoices_JobName} " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    fi
-			fi
-			# Prepare the shell dedicated to offline rebuild
-			if [ $DRYRUN -le 1 ]; then
-			    echo "IGCM_sys_rebuild ${file_in} ${generic_file_name}_*.nc   " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_Verif_Exit_Post                              " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			fi
-			#
-			# Load Patch we need to apply and apply
-			if [ $DRYRUN -le 1 ]; then
-			    if [ X$( eval echo \${${compname}_${flag_post}_Patches[0]} ) !=  X${NULL_STR} ]; then
-				for Patch in $( eval echo \${${compname}_${flag_post}_Patches[*]} ); do
-				    echo ". ${libIGCM_POST}/libIGCM_post/IGCM_${Patch}.ksh" >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_${Patch} ${file_in}                        " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_debug_Verif_Exit_Post                      " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				done
-			    fi
-			fi
-			#
-			if [ $DRYRUN -le 1 ]; then
-			    echo "IGCM_sys_Put_Out ${file_in} ${file_out}                 " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_Verif_Exit_Post                              " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_sys_Rm ${generic_file_name}_*.nc                   " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			fi
-			SaveOnArchive=false
-		    fi
-		fi
-		#
-		if [ ${SaveOnArchive} = true ] ; then
-		    #
-		    # If we need to apply a patch we use TMP DIRECTORY before ARCHIVING if asynchronous rebuild is on
-		    #
-		    thereisapatch=$( eval echo \${${compname}_${flag_post}_Patches[0]} )
-		    
-		    if ( [ ! X${thereisapatch} =  X${NULL_STR} ] && [ ! X${config_Post_RebuildFrequency} = X ] && [ ! X${config_Post_RebuildFrequency} = XNONE ] ) ; then
-			if [ -f ${file_in} ] ; then
-                            [ ! -d ${RUN_DIR}/REBUILD_${PeriodDateBegin} ] && IGCM_sys_Mkdir ${RUN_DIR}/REBUILD_${PeriodDateBegin}
-
-			    IGCM_sys_Mv ${file_in} ${RUN_DIR}/REBUILD_${PeriodDateBegin}
-			    eval FileToBeDeleted[${#FileToBeDeleted[@]}]=REBUILD_${PeriodDateBegin}/${file_in} > /dev/null 2>&1
-			    #
-			    if [ $DRYRUN -le 1 ]; then
-				if [ ! -f ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh ] ; then
-				    echo "#!/bin/ksh                                          " > ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "function IGCM_FlushRebuild                          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "{                                                   " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_debug_PushStack \"IGCM_FlushRebuild\"          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_debug_Print 1 \"IGCM_FlushRebuild\"            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				fi
-                                #
-				for Patch in $( eval echo \${${compname}_${flag_post}_Patches[*]} ); do
-				    echo ". ${libIGCM_POST}/libIGCM_post/IGCM_${Patch}.ksh    " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_${Patch} ${file_in}                            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				    echo "IGCM_debug_Verif_Exit_Post                          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				done
-			        #
-				echo "IGCM_sys_Put_Out ${file_in} ${file_out}                 " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-				echo "IGCM_debug_Verif_Exit_Post                              " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-		                #
-			    fi
-			fi
-		    else
-                        [ ! -d ${RUN_DIR}/REBUILD_${PeriodDateBegin} ] && IGCM_sys_Mkdir ${RUN_DIR}/REBUILD_${PeriodDateBegin}
-			if [ ! -f ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh ] ; then
-			    echo "#!/bin/ksh                                          " > ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "function IGCM_FlushRebuild                          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "{                                                   " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_PushStack \"IGCM_FlushRebuild\"          " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "IGCM_debug_Print 1 \"IGCM_FlushRebuild\"            " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			    echo "echo                                                " >> ${RUN_DIR}/REBUILD_${PeriodDateBegin}/rebuild.ksh
-			fi
-
-			IGCM_sys_Put_Out ${file_in} ${file_out}
-			[ $? -eq 0 ] && eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_in}" > /dev/null 2>&1
-			if [ ${nb_rebuild_file} -gt 1 ] ; then
-			    for DelFile in $( ls | grep "${generic_file_name}[_0-9]*.nc" ) ; do
-				eval FileToBeDeleted[${#FileToBeDeleted[@]}]=${DelFile} > /dev/null 2>&1
-			    done
-			fi
-		    fi
-		fi
-		(( i=i+3 ))
-	    done
-	fi
-
-	# Save Output Text files of models
-	#---------------------------------
-	
-	IGCM_card_DefineArrayFromOption ${card} OutputText List
-	ListTextName=${compname}_OutputText_List
-	
- 	eval TextName0=\${${ListTextName}[0]} > /dev/null 2>&1
-	if [ X${TextName0} != X${NULL_STR} ] ; then
-	    eval NbFiles=\${#${ListTextName}[@]} > /dev/null 2>&1
-
-	    (( i=0 ))
-	    until [ $i -eq $NbFiles ]; do
-		eval file_in=\${${ListTextName}[$i]} > /dev/null 2>&1
-		(( i=i+1 ))
-
-		unset list_file
-		#set +A list_file -- $( ls ${file_in}* | sort 2>/dev/null )
-                #  result for a a1 a10 a2 with file_in=a a a1 a2 a10
-		set +A list_file -- $( [ -f ${file_in} ] && ls ${file_in} ; for i in $(ls ${file_in}* 2>/dev/null | sed "s/${file_in}//" | sort -n) ; do ls ${file_in}$i ; done )
-		nlist_file=${#list_file[@]}
-		if [ ${nlist_file} -gt 1 ] ; then
-		    if ( ${compactoutputs} ) ; then
-			eval file_out=${PREFIX}_${file_in}
-
-			IGCM_debug_Print 2 "Parallelism of Text Output with ${nlist_file} files."
-			IGCM_debug_Print 2 "Compact files in ${file_out} : " ${list_file[*]}
-			echo ${list_file[*]} > ${file_out}
-			echo "
-" >> ${file_out}
-			
-			(( i_ = 0 ))
-			for file in ${list_file[@]}
-			do
-			    echo "_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ " >> ${file_out}
-			    echo "| " ${i_} " " ${file} >> ${file_out}
-			    echo "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - " >> ${file_out}
-			    cat ${file} | sed "s/\(.*\)/${i_}\1/" ${file} >> ${file_out}
-			    echo "
-" >> ${file_out}
-			    eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file}" > /dev/null 2>&1
-			    (( i_ = i_ + 1 ))
-			done
-			eval IGCM_sys_Put_Out ${file_out} \${R_OUT_${comp}_D}/${file_out}
-			eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_out}" > /dev/null 2>&1
-
-			if ( ${ExecutionFail} ) ; then
-			    IGCM_sys_Cp ${file_out} ${SUBMIT_DIR}/Debug
-			fi
-		    else
-			for file in ${list_file[@]}
-			do
-			    eval IGCM_sys_Put_Out ${file} \${R_OUT_${comp}_D}/${PREFIX}_${file}
-			    eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file}" > /dev/null 2>&1
-			done
-			if ( ${ExecutionFail} ) ; then
-			    IGCM_sys_Cp ${file} ${SUBMIT_DIR}/Debug/${PREFIX}_${file}
-			fi
-		    fi
-		else
-		    if ( [ -f ${file_in}_0000 ] || [ -f ${file_in}0 ] ) ; then
-			eval IGCM_sys_Mv ${file_in}* ${file_in}
-		    fi
-		    eval IGCM_sys_Put_Out ${file_in} \${R_OUT_${comp}_D}/${PREFIX}_${file_in}
-		    [ $? -eq 0 ] && eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${file_in}" > /dev/null 2>&1
-
-		    if ( ${ExecutionFail} ) ; then
-			IGCM_sys_Cp ${file_in} ${SUBMIT_DIR}/Debug/${PREFIX}_${file_in}
-		    fi
-		fi
-	    done
-	fi
-    done
-
-    IGCM_debug_PopStack "IGCM_comp_Finalize"
+  done
+  IGCM_debug_PopStack "IGCM_comp_Finalize"
 }
